% CoMa2 - SS11
% Aufg.5.2
function [S,A] = sumnc(ab,f,n,r)
% summierte Newton-Ctes-Formeln fr r=1,2 oder 3

% Inputs: Vektor ab mit den Intervallgrenzen, Funktion f (als 
% function handle einzugeben, z.B. f = @(x) sin(x)), Anzahl n der
% Teilintervalle, Anzahl r der Sttzstellen in einem Teilintervall (r=1,2 
% oder 3)
% Outputs: Wert S der Quadraturformel, Anzahl A der f-Auswertungen

a = ab(1);  b = ab(2);  % damit liest es sich besser

h = (b-a)/n;    % Abstand zwischen zwei Gitterpunkten    

if r==1
    % summ.Trapezregel (siehe auch S.18 im Skript)
    x = a:h:b;  % alle Sttzstellen
    S = (h/2)*sum(f(x(1:n))+f(x(2:n+1)));
    A = length(x);
    % oder A = n+1;    % (Skript S.19)
elseif r==2
    % summ.Simpsonregel (siehe S.19 im Skript)
    x = a:h/2:b;    % alle Sttzstellen
    S = (h/6)*sum(f(x(1:2:(2*n-1))) + 4*f(x(2:2:(2*n))) + f(x(3:2:(2*n+1))));
    A = length(x);
    % oder A = 2*n+1;    % (Skript S.20)
elseif r==3
    % summ.3/8-Regel; ist nicht so schwer herzuleiten...
    x = a:h/3:b;    % alle Sttzstellen
    S = (h/8)*sum(f(x(1:3:(3*n-2))) + 3*f(x(2:3:(3*n-1))) + 3*f(x(3:3:(3*n))) + f(x(4:3:(3*n+1))));
    A = length(x);
    % oder A = 3*n+1;
else
    error('kann ich nicht...');
end